package de.ozgcloud.bescheid;

import java.io.File;
import java.util.Optional;

import de.ozgcloud.bescheid.vorgang.Vorgang;
import de.ozgcloud.bescheid.vorgang.VorgangId;
import de.ozgcloud.common.binaryfile.FileId;
import lombok.Builder;
import lombok.Getter;
import lombok.With;

@Builder(toBuilder = true)
@Getter
public class Bescheid {

	public static final String FIELD_STATUS = "status";
	public static final String FIELD_BESCHIEDEN_AM = "beschiedenAm";
	public static final String FIELD_BEWILLIGT = "bewilligt";
	public static final String FIELD_BESCHEID_DOCUMENT = "bescheidDocument";
	public static final String FIELD_ATTACHMENTS = "attachments";
	public static final String FIELD_SEND_BY = "sendBy";
	public static final String FIELD_NACHRICHT_TEXT = "nachrichtText";
	public static final String FIELD_NACHRICHT_SUBJECT = "nachrichtSubject";

	private VorgangId vorgangId;

	private boolean genehmigt;
	private UserId createdBy;

	private String bescheidFileName;
	private File bescheidFile;
	@With
	private FileId bescheidFileId;
	private String contentType;
	private long size;

	@Builder.Default
	private Optional<String> nachrichtSubject = Optional.empty();
	@Builder.Default
	private Optional<String> nachrichtText = Optional.empty();

	private Vorgang.ServiceKonto serviceKonto;

	public enum Status {
		DRAFT, SENT;

		public boolean not(Object value) {
			return !hasValue(value);
		}

		public boolean hasValue(Object value) {
			return this.name().equalsIgnoreCase(String.valueOf(value));
		}
	}

	public enum SendBy {
		NACHRICHT, MANUAL;

		public boolean notValue(Object sendByValue) {
			return !hasValue(sendByValue);
		}

		public boolean hasValue(Object sendByValue) {
			return this.name().equalsIgnoreCase(String.valueOf(sendByValue));
		}

	}
}
