package de.ozgcloud.bescheid.nachricht;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import de.ozgcloud.nachrichten.postfach.GrpcSaveNachrichtDraftRequest;
import de.ozgcloud.nachrichten.postfach.PostfachServiceGrpc.PostfachServiceBlockingStub;
import io.grpc.ClientInterceptor;
import net.devh.boot.grpc.client.inject.GrpcClient;

@Service
class NachrichtRemoteService {

	@GrpcClient("nachrichten-manager")
	private PostfachServiceBlockingStub serviceStub;

	@Autowired
	private NachrichtMapper mapper;

	@Autowired
	private ClientInterceptor bescheidCallContextInterceptor;

	public void saveDraft(Nachricht nachricht) {
		serviceStub.withInterceptors(bescheidCallContextInterceptor)
				.saveNachrichtDraft(buildRequest(nachricht));
	}

	GrpcSaveNachrichtDraftRequest buildRequest(Nachricht nachricht) {
		return GrpcSaveNachrichtDraftRequest.newBuilder()
				.setVorgangId(nachricht.getVorgangId().toString())
				.setNachricht(mapper.mapToGrpc(nachricht))
				.build();
	}
}
