package de.ozgcloud.bescheid.nachricht;

import static org.assertj.core.api.Assertions.*;
import static org.mockito.ArgumentMatchers.*;
import static org.mockito.Mockito.*;

import org.junit.jupiter.api.BeforeEach;
import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;
import org.mockito.InjectMocks;
import org.mockito.Mock;

import de.ozgcloud.bescheid.vorgang.VorgangTestFactory;
import de.ozgcloud.nachrichten.postfach.GrpcPostfachNachricht;

class NachrichtRemoteServiceTest {

	@InjectMocks
	private NachrichtRemoteService remoteService;

	@Mock
	private NachrichtMapper mapper;

	@Nested
	class TestSaveDarft {
		@Nested
		class BuildRequest {
			private Nachricht nachricht = NachrichtTestFactory.create();
			private GrpcPostfachNachricht grpcNachricht = GrpcPostfachNachrichtTestFactory.create();

			@BeforeEach
			void initMocks() {
				when(mapper.mapToGrpc(any())).thenReturn(grpcNachricht);
			}

			@Test
			void shouldCallMapper() {
				remoteService.buildRequest(nachricht);

				verify(mapper).mapToGrpc(nachricht);
			}

			@Test
			void shouldSetNachricht() {
				var request = remoteService.buildRequest(nachricht);

				assertThat(request.getNachricht()).isSameAs(grpcNachricht);
			}

			@Test
			void shouldSetVorgangId() {
				var request = remoteService.buildRequest(nachricht);

				assertThat(request.getVorgangId()).isEqualTo(VorgangTestFactory.ID.toString());
			}
		}
	}

}
