package de.ozgcloud.bescheid.nachricht;

import static org.assertj.core.api.Assertions.*;

import java.util.Optional;

import org.junit.jupiter.api.Nested;
import org.junit.jupiter.api.Test;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.info.BuildProperties;
import org.springframework.boot.test.mock.mockito.MockBean;

import de.ozgcloud.apilib.common.command.OzgCloudCommandService;
import de.ozgcloud.apilib.common.command.grpc.CommandMapper;
import de.ozgcloud.bescheid.BescheidTestFactory;
import de.ozgcloud.common.test.ITCase;

@ITCase
class NachrichtServiceITCase {

	@Autowired
	private NachrichtService service;
	@MockBean
	private OzgCloudCommandService commandService;
	@MockBean
	private CommandMapper commandMapper;
	@MockBean
	private BuildProperties buildProperties;

	@Nested
	class TestBuildMessage {
		@Test
		void shouldBuildMessage() {
			var message = service.buildMessage(BescheidTestFactory.create());

			assertThat(message).isNotBlank();
		}

		@Test
		void shouldBeGenehmigt() {
			var message = service.buildMessage(BescheidTestFactory.createBuilder().genehmigt(true).nachrichtText(Optional.empty()).build());

			assertThat(message).contains("genehmigt").doesNotContain("abgelehnt");
		}

		@Test
		void shouldBeAbgelehnt() {
			var message = service.buildMessage(BescheidTestFactory.createBuilder().genehmigt(false).nachrichtText(Optional.empty()).build());

			assertThat(message).contains("abgelehnt").doesNotContain("genehmigt");
		}
	}

}
