package de.ozgcloud.bescheid.nachricht;

import java.time.ZonedDateTime;
import java.util.UUID;

import de.ozgcloud.bescheid.UserId;
import de.ozgcloud.bescheid.vorgang.VorgangTestFactory;

public class NachrichtTestFactory {

	public static final NachrichtId ID = NachrichtId.from(UUID.randomUUID().toString());

	public static final String SUBJECT = "subject of message";
	public static final String MAIL_BODY = "Lorem ipsum";

	public static final UserId CREATED_BY = UserId.from(UUID.randomUUID().toString());
	public static final ZonedDateTime CREATED_AT = ZonedDateTime.now().withNano(0);

	public static Nachricht create() {
		return createBuilder().build();
	}

	public static Nachricht.NachrichtBuilder createBuilder() {
		return Nachricht.builder()
				.id(ID)
				.vorgangId(VorgangTestFactory.ID)
				.subject(SUBJECT)
				.mailBody(MAIL_BODY)
				.createdBy(CREATED_BY)
				.createdAt(CREATED_AT);
	}
}
