/*
 * Copyright (C) 2022 Das Land Schleswig-Holstein vertreten durch den
 * Ministerpräsidenten des Landes Schleswig-Holstein
 * Staatskanzlei
 * Abteilung Digitalisierung und zentrales IT-Management der Landesregierung
 *
 * Lizenziert unter der EUPL, Version 1.2 oder - sobald
 * diese von der Europäischen Kommission genehmigt wurden -
 * Folgeversionen der EUPL ("Lizenz");
 * Sie dürfen dieses Werk ausschließlich gemäß
 * dieser Lizenz nutzen.
 * Eine Kopie der Lizenz finden Sie hier:
 *
 * https://joinup.ec.europa.eu/collection/eupl/eupl-text-eupl-12
 *
 * Sofern nicht durch anwendbare Rechtsvorschriften
 * gefordert oder in schriftlicher Form vereinbart, wird
 * die unter der Lizenz verbreitete Software "so wie sie
 * ist", OHNE JEGLICHE GEWÄHRLEISTUNG ODER BEDINGUNGEN -
 * ausdrücklich oder stillschweigend - verbreitet.
 * Die sprachspezifischen Genehmigungen und Beschränkungen
 * unter der Lizenz sind dem Lizenztext zu entnehmen.
 */
package de.ozgcloud.vorgang.vorgang;

public class ZustaendigeStelleTestFactory {

	public static final String ORGANISATIONSEINHEIT_ID = GrpcZustaendigeStelleTestFactory.ORGANISATIONSEINHEIT_ID;
	public static final String BEZEICHNUNG = "Amt für Kleintiere und Viehzeug";
	public static final String EMAIL = GrpcZustaendigeStelleTestFactory.EMAIL;
	public static final String GEMEINDE_SCHLUESSEL = "1029385858";
	public static final String AMTLICHER_REGIONAL_SCHLUESSEL = "09876512";
	public static final String HAUSANSCHRIFT_STRASSE = "Musterstraße 1";
	public static final String HAUSANSCHRIFT_PLZ = "12345";
	public static final String HAUSANSCHRIFT_ORT = "Musterhausen";
	public static final String TELEFON = "0894578199358";

	public static ZustaendigeStelle create() {
		return createBuilder().build();
	}

	public static ZustaendigeStelle.ZustaendigeStelleBuilder createBuilder() {
		return ZustaendigeStelle.builder() //
				.organisationseinheitenId(ORGANISATIONSEINHEIT_ID)
				.bezeichnung(BEZEICHNUNG)
				.email(EMAIL)
				.gemeindeSchluessel(GEMEINDE_SCHLUESSEL)
				.amtlicherRegionalSchluessel(AMTLICHER_REGIONAL_SCHLUESSEL)
				.hausanschriftStrasse(HAUSANSCHRIFT_STRASSE)
				.hausanschriftPlz(HAUSANSCHRIFT_PLZ)
				.hausanschriftOrt(HAUSANSCHRIFT_ORT)
				.telefon(TELEFON);
	}
}
